 function [x] = fom (A, b, x0, tol, m) 
% function [x] = fom (A, b, x0, tol, m) 
%%-----------------------------------------------
r = b - A*x0;
ro = norm(r,2);
V(:,1) = r/ro;
rs(1) = ro;  
for i=1:m 
    i1 = i + 1  ;
    V(:,i1) = A*V(:,i)  ;
%------     modified GS  ;
    for j=1:i
        t = V(:,j)'*V(:,i1)  ;
        H(j,i) = t  ;
	V(:,i1) = V(:,i1) - t*V(:,j)  ;
    end
    for k=2:i
        H(k,i) = H(k,i) - ll(k)*H(k-1,i);
    end 
    rs(i) = rs(i)/H(i,i); 
    if (abs(rs(i)) < tol)
       x = x0 + Vm*triu(H)\rs';
       break
    end
                

    t = norm(V(:,i1),2)  ;
    H(i1,i) = t  ;
    if (t  ~= 0.0)  
        t = 1.0 / t  ;
	V(:,i1) = V(:,i1)*t  ;
    end
end  
