 function x = cgauss (A, b,p)
%---------------------------------------------------
%  function x = cguass(A, b,p) 
%  solves A x  = b by Gaussian elimination using
%  p-digit arithmetic. 
%---------------------------------------------------
 n = size(A,1) ;
 A = [A,b]; 
 A = chop(A,p) ;
 for k=1:n-1 
   for i=k+1:n
     piv =  chop( A(i,k) / A(k,k) ,p);
     A(i,k:n+1) = chop( A(i,k:n+1) - chop(piv*A(k,k:n+1),p), p) ;
   end
 A 
 end 
 x = cbacksolv(A,A(:,n+1),p); 
