function [d,l] = trid (a, d, c,sigma)
%% function [r] = trid (a, d, c) 
%% algorithm for factoring  tridag. matrices
%%  with a(1) = c(n) = 0 
%% 
n = length(d);
count = 0;
d(1) = d(1)-sigma;
for k=2:n
    piv = a(k)/d(k-1);
    d(k) = d(k) - sigma - piv*c(k-1);
    l(k) = piv;
end
 
